[@rxap/data-source](../wiki/globals) / ObservableDataSource

# Class: ObservableDataSource\<Data\>

Defined in: [packages/angular/data-source/src/lib/observable.data-source.ts:23](https://gitlab.com/rxap/packages/-/blob/e40fbf25c2cedeb065b661a89d70669104014cad/packages/angular/data-source/src/lib/observable.data-source.ts#L23)

## Extends

- [`BaseDataSource`](../wiki/Class.BaseDataSource)\<`Data`, [`ObservableDataSourceMetadata`](../wiki/Interface.ObservableDataSourceMetadata)\<`Data`\>\>

## Type Parameters

• **Data**

## Constructors

### new ObservableDataSource()

> **new ObservableDataSource**\<`Data`\>(`observable`, `metadata`): [`ObservableDataSource`](../wiki/Class.ObservableDataSource)\<`Data`\>

Defined in: [packages/angular/data-source/src/lib/observable.data-source.ts:25](https://gitlab.com/rxap/packages/-/blob/e40fbf25c2cedeb065b661a89d70669104014cad/packages/angular/data-source/src/lib/observable.data-source.ts#L25)

#### Parameters

##### observable

`null` | `Observable`\<`Data`\>

##### metadata

`null` | [`ObservableDataSourceMetadata`](../wiki/Interface.ObservableDataSourceMetadata)\<`Data`\>

#### Returns

[`ObservableDataSource`](../wiki/Class.ObservableDataSource)\<`Data`\>

#### Overrides

[`BaseDataSource`](../wiki/Class.BaseDataSource).[`constructor`](../wiki/Class.BaseDataSource#constructors)

## Properties

### \_\_id

> **\_\_id**: `string`

Defined in: [packages/angular/definition/src/lib/definition.ts:61](https://gitlab.com/rxap/packages/-/blob/e40fbf25c2cedeb065b661a89d70669104014cad/packages/angular/definition/src/lib/definition.ts#L61)

**`Internal`**

unique internal id

#### Inherited from

[`BaseDataSource`](../wiki/Class.BaseDataSource).[`__id`](../wiki/Class.BaseDataSource#__id)

***

### \_connectedViewer

> `protected` **\_connectedViewer**: `Map`\<`string`, `Observable`\<`Data`\>\>

Defined in: [packages/angular/data-source/src/lib/base.data-source.ts:78](https://gitlab.com/rxap/packages/-/blob/e40fbf25c2cedeb065b661a89d70669104014cad/packages/angular/data-source/src/lib/base.data-source.ts#L78)

#### Inherited from

[`BaseDataSource`](../wiki/Class.BaseDataSource).[`_connectedViewer`](../wiki/Class.BaseDataSource#_connectedviewer)

***

### \_connectedViewerTeardown

> `protected` **\_connectedViewerTeardown**: `Map`\<`string`, `TeardownLogic`\>

Defined in: [packages/angular/data-source/src/lib/base.data-source.ts:79](https://gitlab.com/rxap/packages/-/blob/e40fbf25c2cedeb065b661a89d70669104014cad/packages/angular/data-source/src/lib/base.data-source.ts#L79)

#### Inherited from

[`BaseDataSource`](../wiki/Class.BaseDataSource).[`_connectedViewerTeardown`](../wiki/Class.BaseDataSource#_connectedviewerteardown)

***

### \_data?

> `protected` `optional` **\_data**: `Data`

Defined in: [packages/angular/data-source/src/lib/base.data-source.ts:104](https://gitlab.com/rxap/packages/-/blob/e40fbf25c2cedeb065b661a89d70669104014cad/packages/angular/data-source/src/lib/base.data-source.ts#L104)

#### Inherited from

[`BaseDataSource`](../wiki/Class.BaseDataSource).[`_data`](../wiki/Class.BaseDataSource#_data)

***

### \_data$

> `protected` **\_data$**: `Observable`\<`Data`\> = `EMPTY`

Defined in: [packages/angular/data-source/src/lib/base.data-source.ts:83](https://gitlab.com/rxap/packages/-/blob/e40fbf25c2cedeb065b661a89d70669104014cad/packages/angular/data-source/src/lib/base.data-source.ts#L83)

#### Inherited from

[`BaseDataSource`](../wiki/Class.BaseDataSource).[`_data$`](../wiki/Class.BaseDataSource#_data$)

***

### \_initialised

> `protected` **\_initialised**: `boolean` = `false`

Defined in: [packages/angular/definition/src/lib/definition.ts:62](https://gitlab.com/rxap/packages/-/blob/e40fbf25c2cedeb065b661a89d70669104014cad/packages/angular/definition/src/lib/definition.ts#L62)

#### Inherited from

[`BaseDataSource`](../wiki/Class.BaseDataSource).[`_initialised`](../wiki/Class.BaseDataSource#_initialised)

***

### \_lastRefreshed

> `protected` **\_lastRefreshed**: `null` \| `Date` = `null`

Defined in: [packages/angular/data-source/src/lib/base.data-source.ts:77](https://gitlab.com/rxap/packages/-/blob/e40fbf25c2cedeb065b661a89d70669104014cad/packages/angular/data-source/src/lib/base.data-source.ts#L77)

#### Inherited from

[`BaseDataSource`](../wiki/Class.BaseDataSource).[`_lastRefreshed`](../wiki/Class.BaseDataSource#_lastrefreshed)

***

### \_retry$

> `protected` **\_retry$**: `Subject`\<`void`\>

Defined in: [packages/angular/data-source/src/lib/base.data-source.ts:90](https://gitlab.com/rxap/packages/-/blob/e40fbf25c2cedeb065b661a89d70669104014cad/packages/angular/data-source/src/lib/base.data-source.ts#L90)

#### Inherited from

[`BaseDataSource`](../wiki/Class.BaseDataSource).[`_retry$`](../wiki/Class.BaseDataSource#_retry$)

***

### \_viewerIds

> `protected` **\_viewerIds**: `Map`\<[`BaseDataSourceViewer`](../wiki/Interface.BaseDataSourceViewer)\<`any`\>, `string`\>

Defined in: [packages/angular/data-source/src/lib/base.data-source.ts:89](https://gitlab.com/rxap/packages/-/blob/e40fbf25c2cedeb065b661a89d70669104014cad/packages/angular/data-source/src/lib/base.data-source.ts#L89)

a map of viewer to view id.
Allows to create a view id from the viewer object reference

#### Inherited from

[`BaseDataSource`](../wiki/Class.BaseDataSource).[`_viewerIds`](../wiki/Class.BaseDataSource#_viewerids)

***

### change$

> `readonly` **change$**: `Subject`\<`Data`\>

Defined in: [packages/angular/data-source/src/lib/base.data-source.ts:67](https://gitlab.com/rxap/packages/-/blob/e40fbf25c2cedeb065b661a89d70669104014cad/packages/angular/data-source/src/lib/base.data-source.ts#L67)

#### Inherited from

[`BaseDataSource`](../wiki/Class.BaseDataSource).[`change$`](../wiki/Class.BaseDataSource#change$)

***

### destroyed$

> `readonly` **destroyed$**: `undefined` \| `Subject`\<`void`\>

Defined in: [packages/angular/definition/src/lib/definition.ts:48](https://gitlab.com/rxap/packages/-/blob/e40fbf25c2cedeb065b661a89d70669104014cad/packages/angular/definition/src/lib/definition.ts#L48)

Emits if the data source is destroyed

#### Inherited from

[`BaseDataSource`](../wiki/Class.BaseDataSource).[`destroyed$`](../wiki/Class.BaseDataSource#destroyed$)

***

### error$

> `readonly` **error$**: `ReplaySubject`\<`Error`\>

Defined in: [packages/angular/data-source/src/lib/base.data-source.ts:73](https://gitlab.com/rxap/packages/-/blob/e40fbf25c2cedeb065b661a89d70669104014cad/packages/angular/data-source/src/lib/base.data-source.ts#L73)

#### Inherited from

[`BaseDataSource`](../wiki/Class.BaseDataSource).[`error$`](../wiki/Class.BaseDataSource#error$)

***

### hasError?

> `optional` **hasError**: `Signal`\<`boolean`\>

Defined in: [packages/angular/data-source/src/lib/base.data-source.ts:94](https://gitlab.com/rxap/packages/-/blob/e40fbf25c2cedeb065b661a89d70669104014cad/packages/angular/data-source/src/lib/base.data-source.ts#L94)

#### Inherited from

[`BaseDataSource`](../wiki/Class.BaseDataSource).[`hasError`](../wiki/Class.BaseDataSource#haserror)

***

### hasError$

> `readonly` **hasError$**: `ToggleSubject`

Defined in: [packages/angular/data-source/src/lib/base.data-source.ts:72](https://gitlab.com/rxap/packages/-/blob/e40fbf25c2cedeb065b661a89d70669104014cad/packages/angular/data-source/src/lib/base.data-source.ts#L72)

#### Inherited from

[`BaseDataSource`](../wiki/Class.BaseDataSource).[`hasError$`](../wiki/Class.BaseDataSource#haserror$)

***

### initialised$

> `readonly` **initialised$**: `undefined` \| `Subject`\<`void`\>

Defined in: [packages/angular/definition/src/lib/definition.ts:52](https://gitlab.com/rxap/packages/-/blob/e40fbf25c2cedeb065b661a89d70669104014cad/packages/angular/definition/src/lib/definition.ts#L52)

Emits if the data source is initialised

#### Inherited from

[`BaseDataSource`](../wiki/Class.BaseDataSource).[`initialised$`](../wiki/Class.BaseDataSource#initialised$)

***

### interceptors

> `readonly` **interceptors**: `undefined` \| `Set`\<`Subject`\<`any`\>\>

Defined in: [packages/angular/definition/src/lib/definition.ts:53](https://gitlab.com/rxap/packages/-/blob/e40fbf25c2cedeb065b661a89d70669104014cad/packages/angular/definition/src/lib/definition.ts#L53)

#### Inherited from

[`BaseDataSource`](../wiki/Class.BaseDataSource).[`interceptors`](../wiki/Class.BaseDataSource#interceptors)

***

### loading?

> `optional` **loading**: `Signal`\<`boolean`\>

Defined in: [packages/angular/data-source/src/lib/base.data-source.ts:92](https://gitlab.com/rxap/packages/-/blob/e40fbf25c2cedeb065b661a89d70669104014cad/packages/angular/data-source/src/lib/base.data-source.ts#L92)

#### Inherited from

[`BaseDataSource`](../wiki/Class.BaseDataSource).[`loading`](../wiki/Class.BaseDataSource#loading)

***

### loading$

> **loading$**: `Observable`\<`boolean`\> = `EMPTY`

Defined in: [packages/angular/data-source/src/lib/base.data-source.ts:71](https://gitlab.com/rxap/packages/-/blob/e40fbf25c2cedeb065b661a89d70669104014cad/packages/angular/data-source/src/lib/base.data-source.ts#L71)

Indicates weather the data source is currently loading new data

#### Inherited from

[`BaseDataSource`](../wiki/Class.BaseDataSource).[`loading$`](../wiki/Class.BaseDataSource#loading$)

***

### metadata

> **metadata**: [`ObservableDataSourceMetadata`](../wiki/Interface.ObservableDataSourceMetadata)

Defined in: [packages/angular/definition/src/lib/definition.ts:44](https://gitlab.com/rxap/packages/-/blob/e40fbf25c2cedeb065b661a89d70669104014cad/packages/angular/definition/src/lib/definition.ts#L44)

#### Inherited from

[`BaseDataSource`](../wiki/Class.BaseDataSource).[`metadata`](../wiki/Class.BaseDataSource#metadata-1)

***

### destroyed$

> `readonly` `static` **destroyed$**: `Subject`\<`BaseDefinition`\<`BaseDefinitionMetadata`\>\>

Defined in: [packages/angular/definition/src/lib/definition.ts:41](https://gitlab.com/rxap/packages/-/blob/e40fbf25c2cedeb065b661a89d70669104014cad/packages/angular/definition/src/lib/definition.ts#L41)

Emits when a new Definition instance is initialised

#### Inherited from

[`BaseDataSource`](../wiki/Class.BaseDataSource).[`destroyed$`](../wiki/Class.BaseDataSource#destroyed$-1)

***

### initialised$

> `readonly` `static` **initialised$**: `Subject`\<`BaseDefinition`\<`BaseDefinitionMetadata`\>\>

Defined in: [packages/angular/definition/src/lib/definition.ts:35](https://gitlab.com/rxap/packages/-/blob/e40fbf25c2cedeb065b661a89d70669104014cad/packages/angular/definition/src/lib/definition.ts#L35)

Emits when a new Definition instance is initialised

#### Inherited from

[`BaseDataSource`](../wiki/Class.BaseDataSource).[`initialised$`](../wiki/Class.BaseDataSource#initialised$-1)

***

### instances

> `readonly` `static` **instances**: `Map`\<`string`, `BaseDefinition`\<`BaseDefinitionMetadata`\>\>

Defined in: [packages/angular/definition/src/lib/definition.ts:27](https://gitlab.com/rxap/packages/-/blob/e40fbf25c2cedeb065b661a89d70669104014cad/packages/angular/definition/src/lib/definition.ts#L27)

A map of active Definition instances

#### Inherited from

[`BaseDataSource`](../wiki/Class.BaseDataSource).[`instances`](../wiki/Class.BaseDataSource#instances)

## Accessors

### data

#### Get Signature

> **get** **data**(): `undefined` \| `Data`

Defined in: [packages/angular/data-source/src/lib/base.data-source.ts:106](https://gitlab.com/rxap/packages/-/blob/e40fbf25c2cedeb065b661a89d70669104014cad/packages/angular/data-source/src/lib/base.data-source.ts#L106)

##### Returns

`undefined` \| `Data`

#### Inherited from

[`BaseDataSource`](../wiki/Class.BaseDataSource).[`data`](../wiki/Class.BaseDataSource#data)

***

### hasConnections

#### Get Signature

> **get** **hasConnections**(): `boolean`

Defined in: [packages/angular/data-source/src/lib/base.data-source.ts:110](https://gitlab.com/rxap/packages/-/blob/e40fbf25c2cedeb065b661a89d70669104014cad/packages/angular/data-source/src/lib/base.data-source.ts#L110)

##### Returns

`boolean`

#### Inherited from

[`BaseDataSource`](../wiki/Class.BaseDataSource).[`hasConnections`](../wiki/Class.BaseDataSource#hasconnections)

***

### id

#### Get Signature

> **get** **id**(): `string`

Defined in: [packages/angular/definition/src/lib/definition.ts:87](https://gitlab.com/rxap/packages/-/blob/e40fbf25c2cedeb065b661a89d70669104014cad/packages/angular/definition/src/lib/definition.ts#L87)

##### Returns

`string`

#### Inherited from

[`BaseDataSource`](../wiki/Class.BaseDataSource).[`id`](../wiki/Class.BaseDataSource#id)

***

### lastRefreshed

#### Get Signature

> **get** **lastRefreshed**(): `null` \| `Date`

Defined in: [packages/angular/data-source/src/lib/base.data-source.ts:74](https://gitlab.com/rxap/packages/-/blob/e40fbf25c2cedeb065b661a89d70669104014cad/packages/angular/data-source/src/lib/base.data-source.ts#L74)

##### Returns

`null` \| `Date`

#### Inherited from

[`BaseDataSource`](../wiki/Class.BaseDataSource).[`lastRefreshed`](../wiki/Class.BaseDataSource#lastrefreshed)

## Methods

### \_connect()

> `protected` **\_connect**(`viewer`): `Observable`\<`Data`\> \| \[`Observable`\<`Data`\>, `TeardownLogic`\]

Defined in: [packages/angular/data-source/src/lib/base.data-source.ts:323](https://gitlab.com/rxap/packages/-/blob/e40fbf25c2cedeb065b661a89d70669104014cad/packages/angular/data-source/src/lib/base.data-source.ts#L323)

#### Parameters

##### viewer

[`BaseDataSourceViewer`](../wiki/Interface.BaseDataSourceViewer)

#### Returns

`Observable`\<`Data`\> \| \[`Observable`\<`Data`\>, `TeardownLogic`\]

#### Inherited from

[`BaseDataSource`](../wiki/Class.BaseDataSource).[`_connect`](../wiki/Class.BaseDataSource#_connect)

***

### \_disconnect()

> `protected` **\_disconnect**(`viewerId`): `void`

Defined in: [packages/angular/data-source/src/lib/base.data-source.ts:308](https://gitlab.com/rxap/packages/-/blob/e40fbf25c2cedeb065b661a89d70669104014cad/packages/angular/data-source/src/lib/base.data-source.ts#L308)

#### Parameters

##### viewerId

`string`

#### Returns

`void`

#### Inherited from

[`BaseDataSource`](../wiki/Class.BaseDataSource).[`_disconnect`](../wiki/Class.BaseDataSource#_disconnect)

***

### applyMetadata()

> **applyMetadata**(`partialMetadata`): `void`

Defined in: [packages/angular/definition/src/lib/definition.ts:111](https://gitlab.com/rxap/packages/-/blob/e40fbf25c2cedeb065b661a89d70669104014cad/packages/angular/definition/src/lib/definition.ts#L111)

#### Parameters

##### partialMetadata

`Partial`\<[`ObservableDataSourceMetadata`](../wiki/Interface.ObservableDataSourceMetadata)\<`Data`\>\>

#### Returns

`void`

#### Inherited from

[`BaseDataSource`](../wiki/Class.BaseDataSource).[`applyMetadata`](../wiki/Class.BaseDataSource#applymetadata)

***

### attach()

> **attach**(`viewerId`): `Observable`\<`Data`\>

Defined in: [packages/angular/data-source/src/lib/base.data-source.ts:210](https://gitlab.com/rxap/packages/-/blob/e40fbf25c2cedeb065b661a89d70669104014cad/packages/angular/data-source/src/lib/base.data-source.ts#L210)

#### Parameters

##### viewerId

`string`

#### Returns

`Observable`\<`Data`\>

#### Inherited from

[`BaseDataSource`](../wiki/Class.BaseDataSource).[`attach`](../wiki/Class.BaseDataSource#attach)

***

### connect()

> **connect**(`viewerOrString`): `Observable`\<`Data`\>

Defined in: [packages/angular/data-source/src/lib/base.data-source.ts:124](https://gitlab.com/rxap/packages/-/blob/e40fbf25c2cedeb065b661a89d70669104014cad/packages/angular/data-source/src/lib/base.data-source.ts#L124)

#### Parameters

##### viewerOrString

`string` | [`BaseDataSourceViewer`](../wiki/Interface.BaseDataSourceViewer)\<`any`\>

#### Returns

`Observable`\<`Data`\>

#### Inherited from

[`BaseDataSource`](../wiki/Class.BaseDataSource).[`connect`](../wiki/Class.BaseDataSource#connect)

***

### derive()

> **derive**(`id`, `metadata`): [`BaseDataSource`](../wiki/Class.BaseDataSource)\<`any`\>

Defined in: [packages/angular/data-source/src/lib/base.data-source.ts:270](https://gitlab.com/rxap/packages/-/blob/e40fbf25c2cedeb065b661a89d70669104014cad/packages/angular/data-source/src/lib/base.data-source.ts#L270)

#### Parameters

##### id

`string`

##### metadata

`Partial`\<[`BaseDataSourceMetadata`](../wiki/Interface.BaseDataSourceMetadata)\> = `...`

#### Returns

[`BaseDataSource`](../wiki/Class.BaseDataSource)\<`any`\>

#### Inherited from

[`BaseDataSource`](../wiki/Class.BaseDataSource).[`derive`](../wiki/Class.BaseDataSource#derive)

***

### ~~destroy()~~

> **destroy**(): `void`

Defined in: [packages/angular/definition/src/lib/definition.ts:118](https://gitlab.com/rxap/packages/-/blob/e40fbf25c2cedeb065b661a89d70669104014cad/packages/angular/definition/src/lib/definition.ts#L118)

#### Returns

`void`

#### Deprecated

use ngOnDestroy instead

#### Inherited from

[`BaseDataSource`](../wiki/Class.BaseDataSource).[`destroy`](../wiki/Class.BaseDataSource#destroy)

***

### disconnect()

> **disconnect**(`viewerOrId`): `void`

Defined in: [packages/angular/data-source/src/lib/base.data-source.ts:225](https://gitlab.com/rxap/packages/-/blob/e40fbf25c2cedeb065b661a89d70669104014cad/packages/angular/data-source/src/lib/base.data-source.ts#L225)

#### Parameters

##### viewerOrId

`string` | [`BaseDataSourceViewer`](../wiki/Interface.BaseDataSourceViewer)\<`any`\>

#### Returns

`void`

#### Inherited from

[`BaseDataSource`](../wiki/Class.BaseDataSource).[`disconnect`](../wiki/Class.BaseDataSource#disconnect)

***

### genericRetryFunction()

> `protected` **genericRetryFunction**(`error`, `retryCount`): `Observable`\<`any`\>

Defined in: [packages/angular/data-source/src/lib/base.data-source.ts:311](https://gitlab.com/rxap/packages/-/blob/e40fbf25c2cedeb065b661a89d70669104014cad/packages/angular/data-source/src/lib/base.data-source.ts#L311)

#### Parameters

##### error

`any`

##### retryCount

`number`

#### Returns

`Observable`\<`any`\>

#### Inherited from

[`BaseDataSource`](../wiki/Class.BaseDataSource).[`genericRetryFunction`](../wiki/Class.BaseDataSource#genericretryfunction)

***

### getMetadata()

> **getMetadata**(): `null` \| [`ObservableDataSourceMetadata`](../wiki/Interface.ObservableDataSourceMetadata)\<`Data`\>

Defined in: [packages/angular/definition/src/lib/definition.ts:107](https://gitlab.com/rxap/packages/-/blob/e40fbf25c2cedeb065b661a89d70669104014cad/packages/angular/definition/src/lib/definition.ts#L107)

#### Returns

`null` \| [`ObservableDataSourceMetadata`](../wiki/Interface.ObservableDataSourceMetadata)\<`Data`\>

#### Inherited from

[`BaseDataSource`](../wiki/Class.BaseDataSource).[`getMetadata`](../wiki/Class.BaseDataSource#getmetadata)

***

### getViewerId()

> **getViewerId**(`viewer`): `string`

Defined in: [packages/angular/data-source/src/lib/base.data-source.ts:114](https://gitlab.com/rxap/packages/-/blob/e40fbf25c2cedeb065b661a89d70669104014cad/packages/angular/data-source/src/lib/base.data-source.ts#L114)

#### Parameters

##### viewer

[`BaseDataSourceViewer`](../wiki/Interface.BaseDataSourceViewer)

#### Returns

`string`

#### Inherited from

[`BaseDataSource`](../wiki/Class.BaseDataSource).[`getViewerId`](../wiki/Class.BaseDataSource#getviewerid)

***

### handelError()

> `protected` **handelError**(`error`): `void`

Defined in: [packages/angular/data-source/src/lib/base.data-source.ts:317](https://gitlab.com/rxap/packages/-/blob/e40fbf25c2cedeb065b661a89d70669104014cad/packages/angular/data-source/src/lib/base.data-source.ts#L317)

#### Parameters

##### error

`any`

#### Returns

`void`

#### Inherited from

[`BaseDataSource`](../wiki/Class.BaseDataSource).[`handelError`](../wiki/Class.BaseDataSource#handelerror)

***

### init()

> **init**(): `void`

Defined in: [packages/angular/definition/src/lib/definition.ts:127](https://gitlab.com/rxap/packages/-/blob/e40fbf25c2cedeb065b661a89d70669104014cad/packages/angular/definition/src/lib/definition.ts#L127)

#### Returns

`void`

#### Inherited from

[`BaseDataSource`](../wiki/Class.BaseDataSource).[`init`](../wiki/Class.BaseDataSource#init)

***

### isConnected()

> **isConnected**(`viewerOrId`): `boolean`

Defined in: [packages/angular/data-source/src/lib/base.data-source.ts:217](https://gitlab.com/rxap/packages/-/blob/e40fbf25c2cedeb065b661a89d70669104014cad/packages/angular/data-source/src/lib/base.data-source.ts#L217)

#### Parameters

##### viewerOrId

`string` | [`BaseDataSourceViewer`](../wiki/Interface.BaseDataSourceViewer)\<`any`\>

#### Returns

`boolean`

#### Inherited from

[`BaseDataSource`](../wiki/Class.BaseDataSource).[`isConnected`](../wiki/Class.BaseDataSource#isconnected)

***

### ngOnDestroy()

> **ngOnDestroy**(): `void`

Defined in: [packages/angular/definition/src/lib/definition.ts:122](https://gitlab.com/rxap/packages/-/blob/e40fbf25c2cedeb065b661a89d70669104014cad/packages/angular/definition/src/lib/definition.ts#L122)

A callback method that performs custom clean-up, invoked immediately
before a directive, pipe, or service instance is destroyed.

#### Returns

`void`

#### Inherited from

[`BaseDataSource`](../wiki/Class.BaseDataSource).[`ngOnDestroy`](../wiki/Class.BaseDataSource#ngondestroy)

***

### refresh()

> **refresh**(): `any`

Defined in: [packages/angular/data-source/src/lib/base.data-source.ts:290](https://gitlab.com/rxap/packages/-/blob/e40fbf25c2cedeb065b661a89d70669104014cad/packages/angular/data-source/src/lib/base.data-source.ts#L290)

#### Returns

`any`

#### Inherited from

[`BaseDataSource`](../wiki/Class.BaseDataSource).[`refresh`](../wiki/Class.BaseDataSource#refresh)

***

### reset()

> **reset**(): `any`

Defined in: [packages/angular/data-source/src/lib/base.data-source.ts:297](https://gitlab.com/rxap/packages/-/blob/e40fbf25c2cedeb065b661a89d70669104014cad/packages/angular/data-source/src/lib/base.data-source.ts#L297)

#### Returns

`any`

#### Inherited from

[`BaseDataSource`](../wiki/Class.BaseDataSource).[`reset`](../wiki/Class.BaseDataSource#reset)

***

### retry()

> **retry**(): `any`

Defined in: [packages/angular/data-source/src/lib/base.data-source.ts:293](https://gitlab.com/rxap/packages/-/blob/e40fbf25c2cedeb065b661a89d70669104014cad/packages/angular/data-source/src/lib/base.data-source.ts#L293)

#### Returns

`any`

#### Inherited from

[`BaseDataSource`](../wiki/Class.BaseDataSource).[`retry`](../wiki/Class.BaseDataSource#retry)

***

### toJSON()

> **toJSON**(): `object`

Defined in: [packages/angular/data-source/src/lib/base.data-source.ts:280](https://gitlab.com/rxap/packages/-/blob/e40fbf25c2cedeb065b661a89d70669104014cad/packages/angular/data-source/src/lib/base.data-source.ts#L280)

#### Returns

`object`

#### Inherited from

[`BaseDataSource`](../wiki/Class.BaseDataSource).[`toJSON`](../wiki/Class.BaseDataSource#tojson)

***

### toPromise()

> **toPromise**(`viewer`): `Promise`\<`Data`\>

Defined in: [packages/angular/data-source/src/lib/base.data-source.ts:264](https://gitlab.com/rxap/packages/-/blob/e40fbf25c2cedeb065b661a89d70669104014cad/packages/angular/data-source/src/lib/base.data-source.ts#L264)

Creates a connection to tha data source and converts the Observable into a
promise and then disconnects the viewer

#### Parameters

##### viewer

[`BaseDataSourceViewer`](../wiki/Interface.BaseDataSourceViewer)

#### Returns

`Promise`\<`Data`\>

#### Inherited from

[`BaseDataSource`](../wiki/Class.BaseDataSource).[`toPromise`](../wiki/Class.BaseDataSource#topromise)

***

### add()

> `static` **add**(`definition`): `void`

Defined in: [packages/angular/definition/src/lib/definition.ts:94](https://gitlab.com/rxap/packages/-/blob/e40fbf25c2cedeb065b661a89d70669104014cad/packages/angular/definition/src/lib/definition.ts#L94)

#### Parameters

##### definition

`BaseDefinition`

#### Returns

`void`

#### Inherited from

[`BaseDataSource`](../wiki/Class.BaseDataSource).[`add`](../wiki/Class.BaseDataSource#add)

***

### remove()

> `static` **remove**(`definition`): `void`

Defined in: [packages/angular/definition/src/lib/definition.ts:102](https://gitlab.com/rxap/packages/-/blob/e40fbf25c2cedeb065b661a89d70669104014cad/packages/angular/definition/src/lib/definition.ts#L102)

#### Parameters

##### definition

`BaseDefinition`

#### Returns

`void`

#### Inherited from

[`BaseDataSource`](../wiki/Class.BaseDataSource).[`remove`](../wiki/Class.BaseDataSource#remove)
